﻿local addOn, ns = ...
local L = ns.L

local gui = {}
gui.title = format("%s v%d %s", addOn, ns.AddOnVer, L['MOVE_HERE'])
gui.args = {}
gui.args.general = {		
	name = L['GENERAl'],
	order = 1,
	expand = false,
	type = "group",
	args = {}
}

gui.args.player = {		
	name = L['PLAYER'],
	order = 2,
	expand = false,
	type = "group",
	args = {}
}

gui.args.leader = {		
	name = L['LEADER'],
	order = 3,
	expand = false,
	type = "group",
	args = {}
}
--[==[
gui.args.LootHistoryFull = {		
	name = "История",
	order = 4,
	expand = false,
	type = "group",
	args = {}
}
]==]
gui.args.LootHistory = {		
	name = L['EXPORT'],
	order = 4.5,
	expand = false,
	type = "group",
	args = {}
}

gui.args.LockOut = {		
	name = L['LOCK_OUT'],
	order = 4.6,
	expand = false,
	type = "group",
	args = {}
}


if ns.debugUI then
gui.args.Debug = {		
	name = "Отладка",
	order = 5,
	expand = false,
	type = "group",
	args = {}
}
gui.args.Debug.args.editBox = {		
	name = "",
	order = 3,
	type = "LootHelper_DebugFrame",
	width = "full", height = 'full',
	set = function()
		
	end,
	get = function()
	
	end,
}

end

local sort_dataByTime = function(x, y)
	return ns.db.lootHistory_Date[x] < ns.db.lootHistory_Date[y]
end

local sort_ServerByAlphabet = function(x,y)
	return x.name < y.name
end

local filter_cutom = nil
local Filter_Select_table = {}
local sortedDataTable = {}
local sortedNameTable = {}
local sortedServerTable = {}
local Indexed_sortedDataTable = {}
local Indexed_sortedNameTable = {}
local Indexed_sortedServerTable = {}

local mRandList = { L["January"], L["February"], L["March"], L["April"], L["May"], L["June"], L["July"], L["August"], L["September"], L["October"], L["November"], L["December"]}
gui.args.LootHistory.args.filters_multi = {
	name = L['FILTER'],
	type = "multiselect",
	order = 2,
	values = function()
		wipe(Filter_Select_table)
		wipe(sortedDataTable)
		wipe(sortedNameTable)
		wipe(sortedServerTable)
		wipe(Indexed_sortedDataTable)
		wipe(Indexed_sortedNameTable)
		wipe(Indexed_sortedServerTable)
		
		local t = Filter_Select_table
		t[1] = { name = L["ALL"],  value = 'ALL' }
		t[2] = { name = L['LATEST'],  value = 'LATEST' }
	
		for data, mType in pairs(ns.db.lootHistory_Date) do
			local month = ns.Histoty_FormatDate_Month(mType)
			
			if not t[3] then
				t[3] = { name = L['DATE'], values = {} }
			end
			
			if not t[3].values[month] then
				t[3].values[month] = { name = mRandList[month] or month, values = {} }
			end
			
			
			sortedDataTable[month] = sortedDataTable[month] or {}
			sortedDataTable[month][#sortedDataTable[month]+1] = data
			
		--	t[3].values[month].values[data] = { name = data, value = data }
		end
		
		for month, datas in pairs( sortedDataTable ) do
			table.sort(sortedDataTable[month], sort_dataByTime)
			
			for i=1, #sortedDataTable[month] do
			
				Indexed_sortedDataTable[sortedDataTable[month][i]] = i
				
				t[3].values[month].values[i] = { name = sortedDataTable[month][i], value = sortedDataTable[month][i] }
			end
		end
		
		for name, class in pairs(ns.db.lootHistory_Units) do
			if not t[4] then
				t[4] = { name = L['SERVER_NAME'], values = {} }
			end
			
			local name1, server = strsplit('-', name)
			
			server = server or 'unknownServer'
			
			
			
			if not sortedServerTable[server] then
				t[4].values[#t[4].values+1] = { name = server, values = {} }
				sortedServerTable[server] = #t[4].values
			end
			--[==[
			if not t[4].values[server] then			
				t[4].values[server] = { name = server, values = {} }
			end
			]==]
			local className, _, _, colorStr = ns.GetClassInfo( class )
			
			t[4].values[sortedServerTable[server]].values[name] = { name = "|c"..colorStr..name1, value = name:gsub('-', '.?') } --value = name1..'-\n'..server }
		end
		if t[4] then
			table.sort(t[4].values, sort_ServerByAlphabet)
		end
		
		for name, class in pairs(ns.db.lootHistory_Units) do
			if not t[5] then
				t[5] = { name = L['CLASS_NAME'], values = {} }
			end
			
			local className, _, _, colorStr = ns.GetClassInfo( class )
			
			if not t[5].values[className] then			
				t[5].values[className] = { name = '|c'..colorStr..className, values = {} }
			end
			
			local name1, server = strsplit('-', name)
			
			server = server or 'unknownServer'
			
			t[5].values[className].values[name] = { name = name1, value = name:gsub('-', '.?') }
		end
		
		for data, tables in pairs(ns.db.lootHistory_Date_Units) do
			if not t[6] then
				t[6] = { name = L['DATE_NAME'], values = {} }
			end
			
			local mType = ns.db.lootHistory_Date[data] 
			local month = ns.Histoty_FormatDate_Month(mType)
			
			if not t[6].values[month] then
				t[6].values[month] = { name = mRandList[month] or month, values = {} }
			end
			
			local index_sorted = Indexed_sortedDataTable[data]
			
			t[6].values[month].values[index_sorted] = { name = data, values = {} }
			
	
			
			for name, class in pairs(tables) do
				
				local className, _, _, colorStr = ns.GetClassInfo( class )
				
				t[6].values[month].values[index_sorted].values[name] = { name = '|c'..colorStr..name, value = data..'\n'..name:gsub('-', '.?') }
			end
			
		end
		
		if ns.db.lootHistory_Encounter_Boss then
			for encID, tables in pairs(ns.db.lootHistory_Encounter_Boss) do
			
				local name = ns.Cache_GetEncounterName(encID)
				
				if name then
					if not t[7] then				
						t[7] = { name = L['ZONE_BOSS'], values = {} }
					end
				
					if not t[7].values[encID] then
						t[7].values[encID] = { name = name or 'Enc:'..encID , values = {} }					
					end
					
					local index = 1
					
					t[7].values[encID].values[index] = { name = L['ALL'], value = 'zone:'..encID }
					
					for bossID in pairs(tables) do
						
						local name = ns.Cache_GetBossNameByID(bossID)
						
						if name then
							index = index + 1
						
							t[7].values[encID].values[index] = { name = name, value = 'boss:'..bossID }
							
						end
					end
				end
				
			end
		end

		wipe(sortedDataTable)
		wipe(Indexed_sortedDataTable)
		
		return t
	end,
	set = function(self, value)			
		filter_cutom = value
		ns.LootHistroy_ShowResults(filter_cutom)
	end,
	get = function(self)
		return filter_cutom
	end,	
}
gui.args.LootHistory.args.reset_history = {
	name = L['RESET'],
	type = "execute",
	order = 2.2,
	set = function()
		ns.History_Reset()
		ns.LootHistory_ResetEditBox()
		filter_cutom = nil
		wipe(Filter_Select_table)
		ns.LootList_ResetLastFromMaxItem()
	end,
	get = function()
		
	end,
}
	
gui.args.LootHistory.args.MainFrame = {		
	name = "",
	order = 3,
	type = "LootHelper_InfoFrame",
	width = "full", height = 'full',
	set = function()
		
	end,
	get = function()
	
	end,
}

--[==[
gui.args.LootHistoryFull.args.MainFrame = {		
	name = "",
	order = 3,
	type = "LootHelper_InfoFrame_History",
	width = "full", height = 'full',
	set = function()
		
	end,
	get = function()
	
	end,
}
]==]
ns.GUI = gui
AleaUI_GUI:RegisterMainFrame(addOn, ns.GUI)


gui.args.general.args.enable = {
	name = L['ENABLE'], desc = L['ENABLE_DESC'],
	order = 1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.enable = not ns.db.enable
	end,
	get = function()
		return ns.db.enable
	end
}

gui.args.general.args.hideMinimap = {
	name = L['SHOW_MINIMAP_BUTTON'],
	order = 1.1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.minimap.hide = not ns.db.minimap.hide
		AleaUI_GUI.GetMinimapButton(addOn):Update(ns.db.minimap)
	end,
	get = function()
		return ns.db.minimap.hide
	end
}

gui.args.general.args.relicTooltipInfoHelp = {
	name = L['SHOW_RELIC_TOOLTIP_HELP'],
	order = 1.2,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.relicTooltipInfoHelp = not ns.db.relicTooltipInfoHelp
	end,
	get = function()
		return ns.db.relicTooltipInfoHelp
	end
}
--[==[
gui.args.general.args.moreHistory = {
	name = 'Расширить историю',
	order = 1.3,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.moreHistory = not ns.db.moreHistory
	end,
	get = function()
		return ns.db.moreHistory
	end
}
]==]
gui.args.general.args.test = {
	name = L['RUN_TEST'],
	order = 2,
	type = 'execute',
	set = function(info)
		ns:ToggleTest()
	end,
	get = function()
		return 
	end
}

gui.args.general.args.openMainFrame = {
	name = L['OPEN_MAINFRAME'],
	desc = L['OPEN_MAINFRAME_DESC'],
	order = 3,
	type = 'execute',
	set = function(info)
		ns.OpenLootRollsMainFrame()
	end,
	get = function()
		return 
	end
}

gui.args.general.args.openMainFrameHistory = {
	name = L['OPEN_MAINFRAME_HISTORY'],
--	desc = L['OPEN_MAINFRAME_DESC_HISTORY'],
	order = 4, width = 'full',
	type = 'execute',
	set = function(info)
		ns.ShowLootListFrame_Alone()
	end,
	get = function()
		return 
	end
}

gui.args.general.args.downloadLink = {
	name = L['DOWNLOAD_LINK'],
	order = 1.2,
	type = 'editbox',
	width = 'full' ,
	set = function(info) end,
	get = function()
		return ns.downloadLink
	end
}

gui.args.player.args.RightClickToHideAllRolls = {
	name = L['ENABLE_RIGHT_CLICK_PASS'], desc = L['ENABLE_RIGHT_CLICK_PASS_DESC'],
	order = 1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.RightClickToHideAllRolls = not ns.db.RightClickToHideAllRolls
	end,
	get = function()
		return ns.db.RightClickToHideAllRolls
	end
}

gui.args.player.args.RollsOnTop = {
	name = L['ENABLE_ROLL_ON_TOP'], desc = L['ENABLE_ROLL_ON_TOP_DESC'],
	order = 1.1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.RollsOnTop = not ns.db.RollsOnTop
		ns:UpdateLootAnchors()
	end,
	get = function()
		return ns.db.RollsOnTop
	end
}

gui.args.player.args.ShowItemLevel = {
	name = L['ENABLE_SHOW_ILVL'], desc = L['ENABLE_SHOW_ILVL_DESC'],
	order = 1.2,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.ShowItemLevel = not ns.db.ShowItemLevel
	end,
	get = function()
		return ns.db.ShowItemLevel
	end
}

gui.args.player.args.ShownMainFrame = {
	name = L['ENABLE_SHOW_MAINFRAME'], desc = L['ENABLE_SHOW_MAINFRAME_DESC'],
	order = 1.3,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.ShownMainFrame = not ns.db.ShownMainFrame
	end,
	get = function()
		return ns.db.ShownMainFrame
	end
}

gui.args.player.args.EnableLootRollLog = {
	name = L['ENABLE_LOOT_ROLL_LOG'], desc = L['ENABLE_LOOT_ROLL_LOG_DESC'],
	order = 1.4,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.EnableLootRollLog = not ns.db.EnableLootRollLog
	end,
	get = function()
		return ns.db.EnableLootRollLog
	end
}

gui.args.player.args.AutoClearLootLog = {
	name = L['ENABLE_AUTO_CLEAR_LOG'], desc = L['ENABLE_AUTO_CLEAR_LOG_DESC'],
	order = 1.5,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.AutoClearLootLog = not ns.db.AutoClearLootLog
	end,
	get = function()
		return ns.db.AutoClearLootLog
	end
}

gui.args.player.args.AuraPassUnusableRolls = {
	name = L['ENABLE_AUTO_PASS_ROLL'], desc = L['ENABLE_AUTO_PASS_ROLL_DESC'],
	order = 1.6,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.AuraPassUnusableRolls = not ns.db.AuraPassUnusableRolls
	end,
	get = function()
		return ns.db.AuraPassUnusableRolls
	end
}

gui.args.player.args.EnableAwardingLoot = {
	name = L['ENABLE_LOOT_AWARDING'], desc = L['ENABLE_LOOT_AWARDING_DESC'],
	order = 1.7,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.EnableAwardingLoot = not ns.db.EnableAwardingLoot
	end,
	get = function()
		return ns.db.EnableAwardingLoot
	end
}

gui.args.player.args.EnableShornLootLink = {
	name = L['ENABLE_SHORT_LOOT_LINK'], desc = L['ENABLE_SHORT_LOOT_LINK_DESC'],
	order = 1.8,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.EnableShornLootLink = not ns.db.EnableShornLootLink
	end,
	get = function()
		return ns.db.EnableShornLootLink
	end
}

gui.args.player.args.EnableTokenItemHook = {
	name = L['ENABLE_TOKEN_ITEM_HOOK'], desc = L['ENABLE_TOKEN_ITEM_HOOK_DESC'],
	order = 1.9,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.EnableTokenItemHook = not ns.db.EnableTokenItemHook
	end,
	get = function()
		return ns.db.EnableTokenItemHook
	end
}

gui.args.player.args['ZoneFilter'] = {
	name = L['AUTO_IGNORE_ZONE_FILER'],
	order = 3,
	embend = true,
	type = "group",
	args = {}
}

for index, data in pairs(ns.default_settings.ignorePerZoneClient) do	
	local name = L[data.name] or data.name	
	gui.args.player.args['ZoneFilter'].args[data.name] = {		
		name = name,
		order = 4,
		embend = true,
		type = "group",
		args = {}
	}

	for index2, data2 in pairs(data.values) do
		local name2 = L[data2.name] or data2.name		
		gui.args.player.args['ZoneFilter'].args[data.name].args['Instance'..data2.name] = {
			name = name2, desc = L['ZONE_DISABLE_DESC'],
			order = index2,
			type = 'toggle',
			set = function(info)
				ns.db.ignorePerZoneClient[index].values[index2].value = not ns.db.ignorePerZoneClient[index].values[index2].value
			end,
			get = function()
				return ns.db.ignorePerZoneClient[index].values[index2].value
			end
		}
	end
end

gui.args.leader.args.enableServer = {
	name = L['ENABLE_SERVER'], desc = L['ENABLE_SERVER_DESC'],
	order = 0.1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.enableServer = not ns.db.enableServer
	end,
	get = function()
		return ns.db.enableServer
	end
}

gui.args.leader.args.SearchSameSession = {
	name = L['ENABLE_AUTO_SEARCH_SAME_SESSION'], desc = L['ENABLE_AUTO_SEARCH_SAME_SESSION_DESC'],
	order = 1,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.SearchSameSession = not ns.db.SearchSameSession
	end,
	get = function()
		return ns.db.SearchSameSession
	end
}

gui.args.leader.args.ColoredRollFilter = {
	name = L['ENABLE_COLORED_ROLL_FILTER'], desc = L['ENABLE_COLORED_ROLL_FILTER_DESC'],
	order = 2,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.ColoredRollFilter = not ns.db.ColoredRollFilter
		ns:UpdateColoredFilterSettings()
	end,
	get = function()
		return ns.db.ColoredRollFilter
	end
}

gui.args.leader.args.GroupUpSameItems = {
	name = L['ENABLE_GROUPED_ITEMS'], desc = L['ENABLE_GROUPED_ITEMS_DESC'],
	order = 2.5,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.groupUpSameItems = not ns.db.groupUpSameItems
	end,
	get = function()
		return ns.db.groupUpSameItems
	end
}

gui.args.leader.args.enableScreenShot = {
	name = L['ENABLE_SCREENSHOT'], desc = L['ENABLE_SCREENSHOT_DESC'],
	order = 2.6,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.enableScreenShot = not ns.db.enableScreenShot
	end,
	get = function()
		return ns.db.enableScreenShot
	end
}

gui.args.leader.args.doStartRollAnonce = {
	name = L['ENABLE_START_ROLL_ANONCE'],
	order = 2.7,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.doStartRollAnonce = not ns.db.doStartRollAnonce
	end,
	get = function()
		return ns.db.doStartRollAnonce
	end
}

gui.args.leader.args.enableAlerts = {
	name = L['ENABLE_ALERTS'],
	order = 2.8,
	width = 'full',
	type = 'toggle',
	set = function(info)
		ns.db.enableAlerts = not ns.db.enableAlerts
	end,
	get = function()
		return ns.db.enableAlerts
	end
}


gui.args.leader.args['ZoneFilter'] = {
	name = L['AUTO_IGNORE_ZONE_FILER'],
	order = 3,
	embend = true,
	type = "group",
	args = {}
}
for index, data in pairs(ns.default_settings.ignorePerZoneServer) do	
	local name = L[data.name] or data.name	
	gui.args.leader.args['ZoneFilter'].args[data.name] = {		
		name = name,
		order = 4,
		embend = true,
		type = "group",
		args = {}
	}

	for index2, data2 in pairs(data.values) do
		local name2 = L[data2.name] or data2.name		
		gui.args.leader.args['ZoneFilter'].args[data.name].args['Instance'..data2.name] = {
			name = name2, desc = L['ZONE_DISABLE_DESC'],
			order = index2,
			type = 'toggle',
			set = function(info)
				ns.db.ignorePerZoneServer[index].values[index2].value = not ns.db.ignorePerZoneServer[index].values[index2].value
			end,
			get = function()
				return ns.db.ignorePerZoneServer[index].values[index2].value
			end
		}
	end
end

gui.args.leader.args['ItemQualirty'] = {		
	name = L['ITEM_QUALITY'],
	desc = L['ITEM_QUALITY_DESC'],
	order = 7,
	embend = true,
	type = "group",
	args = {}
}
do
	for i=0, #ns.default_settings.lootQuality do
		local r, g, b, hex = GetItemQualityColor(i)
		gui.args.leader.args['ItemQualirty'].args['lootQuality'..i+1] = {
			name = '|c'..hex..L['ITEM_QUALITY_'..i], 
			desc = L['ITEM_QUALITY_DESC'],
			order = i+1,
			type = 'toggle',
			set = function(info)
				ns.db.lootQuality[i] = not ns.db.lootQuality[i]
			end,
			get = function()
				return ns.db.lootQuality[i]
			end
		}
	end
end

gui.args.leader.args['Buttons'] = {		
	name = L['BUTTONS'],
	order = 9,
	embend = true,
	type = "group",
	args = {}
}
do
	local rollTypes = {
		['roll'] = L['ROLL'],
		['normal'] = L['NORMAL'],
	}
	
	local buttonTypes = {
		['need'] = 'need',
		['offspec'] = 'offspec',
		['upgrade'] = 'upgrade',
		['transmog'] = 'transmog',
	
	}
	
	local buttonOrder = {}
	
	function ns:UpdateButtonListTable()
		for i=1, 6 do
			if gui.args.leader.args['Buttons'].args['Button'..i] then
				gui.args.leader.args['Buttons'].args['Button'..i] = nil			
			end
		end
		
		buttonOrder = {}
		
		for i=1, ns.db.LootRollButtonsNumButtons do
			buttonOrder[i] = i
		end
		
		for i=1, ns.db.LootRollButtonsNumButtons do
		
			gui.args.leader.args['Buttons'].args['Button'..i] = {		
				name = L['BUTTON']..' '..i,
				order = i+10,
				embend = true,
				type = "group",
				args = {}
			}
			
			gui.args.leader.args['Buttons'].args['Button'..i].args.Order = {
				name = L['BUTTON_ORDER'],
				order = 0.1,
				type = 'dropdown',
				values = buttonOrder,
				set = function(info, value)
					if i == value then return end
					
					local from = ns.db.LootRollButtons[value]
					local to = ns.db.LootRollButtons[i]
					
					ns.db.LootRollButtons[value] = to
					ns.db.LootRollButtons[i] = from
					--ns.db.LootRollButtons[i].arg = value
				end,
				get = function(info)				
					return i
				end
			}
			
			gui.args.leader.args['Buttons'].args['Button'..i].args.Name = {
				name = L['BUTTON_NAME'],
				order = 1,
				type = 'editbox',
				set = function(info, value)
					ns.db.LootRollButtons[i].name = value
				end,
				get = function(info)				
					return ns.db.LootRollButtons[i].name
				end
			}
			
			gui.args.leader.args['Buttons'].args['Button'..i].args.RollType = {
				name = L['BUTTON_ROLL_TYPE'],
				order = 2,
				type = 'dropdown',
				values = rollTypes,
				set = function(info, value)
					ns.db.LootRollButtons[i].arg = value
				end,
				get = function(info)				
					return ns.db.LootRollButtons[i].arg
				end
			}
			
			gui.args.leader.args['Buttons'].args['Button'..i].args.ButtonType = {
				name = L['BUTTON_TYPE'],
				order = 3,
				type = 'dropdown',
				values = buttonTypes,
				set = function(info, value)
					ns.db.LootRollButtons[i].tip = value
				end,
				get = function(info)				
					return ns.db.LootRollButtons[i].tip
				end
			}
		end
	
	end
	
	gui.args.leader.args['Buttons'].args['buttonAmout'] = {
		name = L['BUTTONS_AMOUNT'], 
		desc = L['BUTTONS_AMOUNT_DESC'],
		order = 1,
		type = 'slider',
		min = 1, max = 6,
		step = 1,
		set = function(info, value)
			ns.db.LootRollButtonsNumButtons = value
			ns:UpdateButtonListTable()
		end,
		get = function()
			return ns.db.LootRollButtonsNumButtons
		end
	}
	
	gui.args.versionCheck ={
		order = 99999,name = L['VERSION'],type = "group",
		args={
			changes  = {
				order = order_1,
				type = "string",
				width = "full",
				name = 'Test',
			}
	
		},
	}
	do
		local versions = {}
		local sortedVersion = {}
		local sort = {}
		
		local function SortFunc(x,y)
			return x>y
		end
		
		local function BuildVersionList()
			local text = ''
			
			table.sort(sort, SortFunc)
			
			for i=1, #sort do
				local ver = sort[i]
				text = text..(i==1 and '' or '\n\n')..'v'..ver..':'
				for a=1, #sortedVersion[ver] do
					text = text.. ( strsplit('-', sortedVersion[ver][a]))..(a==#sortedVersion[ver] and '' or '\n')
				end
			end
			--[==[
			for sender, version in pairs(versions) do
				text = text..sender..' - '..version..'\n'
			end
			]==]
			gui.args.versionCheck.args.changes.name = text
		end
		
		local event = CreateFrame('Frame')
		event:RegisterEvent("CHAT_MSG_ADDON")
		
		event:SetScript('OnEvent', function(self, event, prefix, message, channel, sender)
			if prefix ~= "LHVCH" then return end
			
			local version, source = strsplit(":", message)
			
			if version and source then
				if not sortedVersion[tonumber(version)] then
					sort[#sort+1] = tonumber(version)
					sortedVersion[tonumber(version)] = {}
				end
				
				if not versions[sender] then
					versions[sender] = version
					
					sortedVersion[tonumber(version)][#sortedVersion[tonumber(version)]+1] = sender
					BuildVersionList()
				end
				
				if versions[sender] ~= version then
					versions[sender] = version
	
					BuildVersionList()
				end
			end
		end)
	end
end


local raidList = {
	[1] = { 768, 14, '768_14' },
	[2] = { 768, 15, '768_15' },
	[3] = { 768, 16, '768_16' },
	
	[4] = { 861, 14, '861_14' },
	[5] = { 861, 15, '861_15' },
	[6] = { 861, 16, '861_16' },
	
	[7] = { 786, 14, '786_14' },
	[8] = { 786, 15, '786_15' },
	[9] = { 786, 16, '786_16' },
}

local function GetDropdownInstanceValue(raidID)	
	for i=1, #raidList do	
		if raidID == raidList[i][3] then
			return i
		end
	end
end

gui.args.LockOut.args.select = {
	name = L['SELECT_INSTANCE'],
	order = 1,
	type = 'dropdown',
	values = function()	
		local t = {}
		
		for i=1, #raidList do
			local name = ns.Cache_GetEncounterName(raidList[i][1])
			
			local difficult = ''
			
			if raidList[i][2] == 14 then
				difficult = L['NORMAL_MODE']
			elseif raidList[i][2] == 15 then
				difficult = L['HEROIC_MODE']
			elseif raidList[i][2] == 16 then
				difficult = L['MYTHIC_MODE']
			end
			
			t[i] = name..'('..difficult..')'
		end
		
		return t
	end,
	set = function(info, value)
		local arg = raidList[value][3]
		ns.ForceShowRaidLockOut = arg
	end,
	get = function(info)				
	
		if ns.ForceShowRaidLockOut then
			return GetDropdownInstanceValue(ns.ForceShowRaidLockOut)	
		else
			local raidID = ns:Client_GetEncounterLockoutID()
			
			if raidID then
				return GetDropdownInstanceValue(raidID)	
			end
		end
		
		return -1
	end
}

gui.args.LockOut.args.request = {
	name = L['REQUEST'],
	order = 2,
	type = 'execute',
	set = function(info)
		local raidID = false

		if ns.IsRealMasterLooter() then
		
			if ns.ForceShowRaidLockOut then
				raidID = ns.ForceShowRaidLockOut
			else
				local raidID_t = ns:Client_GetEncounterLockoutID()			
				if raidID_t then raidID = raidID_t end
			end
			
			
			if raidID then
				ns:SendMessage(raidID, ns.channelNameLockOutR)	
			end

		end
	end,
	get = function(info)

		return 
	end,
}

gui.args.LockOut.args.mainFrame = {		
	name = "",
	order = 2,
	type = "LootHelper_LockOutFrame",
	width = "full", height = 'full',
	set = function()
		
	end,
	get = function()
	
	end,
}